#include "gtable.h"
#include <stdio.h>

/* 
   A simple test program for gtable routines.  
   This looks at the common uses of the gtable routines to create a 
   table from running data 
*/

int main( int argc, char *argv[] )
{
    Gtable *gtable;
    int i, j;

    gtable = GtableCreate( 0, 0 );
    for (i=0; i<4; i++) {
	GtableNewRow( gtable );
	GtableAddEntry( gtable, -1, -1, "new" );
	GtableAddEntryFmt( gtable, -1, -1, "c:%d", i );
	for (j=0; j<3; j++) {
	    GtableAddEntryFmt( gtable, -1, -1, "c2:%d-%d", i, j );
	}
    }

    /* Output as text */
    GtableOutput( gtable, Gtable_CreateText(0,0), 0 );

    GtableOutput( gtable, Gtable_CreateHTML(0,0), 0 );

    GtableFree( &gtable );

    return 0;
}
