/* Old utility routines.  Unused for now */

static void getrange_int( const int[], int, 
			  int [], int [], int [], int [], int [] );



static void getrange_int( const int vals[], int count, 
			  int sumout[], int minout[], int maxout[],
			  int minloc[], int maxloc[] )
{
    typedef struct { int val; int loc; } twoint;
    twoint *lvals, *gvals;
    int i, nprocs, rank;

    lvals = (twoint *)malloc( 2 * count * sizeof(twoint) );
    gvals = lvals + count;

    PMPI_Comm_size( MPI_COMM_WORLD, &nprocs );
    PMPI_Comm_rank( MPI_COMM_WORLD, &rank );
    for (i=0; i<count; i++) {
	lvals[i].val = vals[i];
	lvals[i].loc = rank;
    }
    PMPI_Reduce( lvals, gvals, count, MPI_2INT, MPI_MAXLOC, 
		 0, MPI_COMM_WORLD );
    for (i=0; i<count; i++) {
	maxout[i] = gvals[i].val;
	maxloc[i] = gvals[i].loc;
    }
    PMPI_Reduce( lvals, gvals, count, MPI_2INT, MPI_MINLOC, 
		 0, MPI_COMM_WORLD );
    for (i=0; i<count; i++) {
	minout[i] = gvals[i].val;
	minloc[i] = gvals[i].loc;
    }
    PMPI_Reduce( (int *)vals, sumout, count, MPI_INT, MPI_SUM, 
		 0, MPI_COMM_WORLD );
    free( lvals );
}


/* Discarded routines */
#ifdef FOO
static void printout_msgstats_collold( int calls[], double sizes[], 
	   double sizes2[], double times[], double times2[],
	   int comm_partners[], long int comm_sizes[], double comm_times[],
           double timesync[], const char *name, 
           void *handle, int llrank, int nprocs )
{
  int sumcalls[NBINS], mincalls[NBINS], maxcalls[NBINS];
  int minloc[NBINS], maxloc[NBINS];
  int minsizeloc[NBINS], maxsizeloc[NBINS];
  int minsize2loc[NBINS], maxsize2loc[NBINS];
  double sumsizes[NBINS], minsizes[NBINS], maxsizes[NBINS];
  double sumsizes2[NBINS], minsizes2[NBINS], maxsizes2[NBINS];
  int mintimeloc[NBINS], maxtimeloc[NBINS];
  int mintime2loc[NBINS], maxtime2loc[NBINS];
  double sumtimes[NBINS], mintimes[NBINS], maxtimes[NBINS];
  double sumtimes2[NBINS], mintimes2[NBINS], maxtimes2[NBINS];
  double sumsynctimes[NBINS], minsynctimes[NBINS], maxsynctimes[NBINS];
  int mintimesyncloc[NBINS], maxtimesyncloc[NBINS];
  double avg_size, stddev_size, avg_time, stddev_time;
  int total_numcalls, total_numpartners;
  int *g_comm_partners;
  long int *g_comm_sizes;
  double *g_comm_times;
  int i,j, call_lbl;
  long int size_lbl;
  double time_lbl;
  char label[45];    /* Graph label */
#ifdef GTABLE
  Gtable *gtable = (Gtable *)handle;
#else
  FILE *pf = (FILE *)handle;
#endif

  char nfname[100];   /* node-file name for topological data */
  char htmlname[100];   /* node-file name for topological data */
  FILE *nfp;         /* node-file file pointer */
  FILE *hfp;         /* html-file file pointer */

  if (!timesync) {
    total_numpartners = 0;
    for (i=0;i<MAX_PROCS;i++) {
      if (comm_partners[i] > 0) total_numpartners++;
    }

    /* Merge some data to proc. 0 */
    g_comm_partners = (int *) malloc( nprocs*MAX_PROCS*sizeof(int) );
    PMPI_Gather ( comm_partners, MAX_PROCS, MPI_INT, 
		  g_comm_partners, MAX_PROCS, MPI_INT, 0, MPI_COMM_WORLD );
    g_comm_sizes = (long int *) malloc( nprocs*MAX_PROCS*sizeof(long int) );
    PMPI_Gather ( comm_sizes, MAX_PROCS, MPI_INT, 
		  g_comm_sizes, MAX_PROCS, MPI_INT, 0, MPI_COMM_WORLD );
    g_comm_times = (double *) malloc( nprocs*MAX_PROCS*sizeof(double) );
    PMPI_Gather ( comm_times, MAX_PROCS, MPI_DOUBLE, 
		  g_comm_times, MAX_PROCS, MPI_DOUBLE, 0, MPI_COMM_WORLD );

  }

  /* These are collective calls that reduce data to process 0 */
  getrange_int( calls, NBINS, sumcalls, mincalls, maxcalls, minloc, maxloc );
  getrange_double( sizes, NBINS, 
		   sumsizes, minsizes, maxsizes, minsizeloc, maxsizeloc );
  getrange_double( sizes2, NBINS, 
		   sumsizes2, minsizes2, maxsizes2, minsize2loc, maxsize2loc );
  getrange_double( times, NBINS, 
		   sumtimes, mintimes, maxtimes, mintimeloc, maxtimeloc );
  getrange_double( times2, NBINS, 
		   sumtimes2, mintimes2, maxtimes2, mintime2loc, maxtime2loc );
  if (timesync) {
      getrange_double( timesync, NBINS, 
		       sumsynctimes, minsynctimes, maxsynctimes, 
		       mintimesyncloc, maxtimesyncloc );
  }


  /* Merge some data to Proc 0 */
  
  if (llrank == 0) {
      /* Compute avg message size, avg time, and sum needed for stddev */
      avg_size=0;
      avg_time=0;
      total_numcalls=0;
      stddev_size=0;
      stddev_time=0;
      for (i=0; i<NBINS; i++) {
	avg_size += sumsizes[i];
	avg_time += sumtimes[i];
	stddev_size += sumsizes2[i];
	stddev_time += sumtimes2[i];
	total_numcalls += sumcalls[i];
      }
      total_numcalls/=nprocs;
      avg_size /= ( (double) total_numcalls * nprocs );
      avg_time /= ( (double) total_numcalls * nprocs );
      stddev_size /= (double) (nprocs * total_numcalls);
      stddev_size = sqrt (stddev_size - avg_size*avg_size);
      stddev_time /= (double) (nprocs * total_numcalls);
      stddev_time = sqrt (stddev_time - avg_time*avg_time);
      if (total_numcalls <2) {
	stddev_size = 0;
	stddev_time = 0;
      }

      /* Create table entries - no longer for each bin, only 'averages'*/
      if (total_numcalls > 0) {
#ifdef GTABLE
	GtableNewRow( gtable );
	GtableAddEntry(gtable, -1, -1, "<AppComm>\n");
	GtableAddEntry(gtable, -1, -1, "<PIB>123456</PIB>\n");
	GtableAddEntryFmt(gtable, -1, -1, "<commtype>%s</commtype>\n", 
			  name);
	GtableAddEntryFmt(gtable, -1, -1, "<numcalls>%d</numcalls>\n", 
			  total_numcalls);
	GtableAddEntryFmt(gtable, -1, -1, "<time>%f</time>\n", 
			  avg_time*total_numcalls);
	GtableAddEntryFmt(gtable, -1, -1, "<avgmsg>%f</avgmsg>\n", 
			  avg_size);
	GtableAddEntryFmt(gtable, -1, -1, "<stddev_size>%f</stddev_size>\n", 
			  stddev_size);
	GtableAddEntryFmt(gtable, -1, -1, "<stddev_time>%f</stddev_time>\n", 
			  stddev_time);
	GtableAddEntryFmt(gtable, -1, -1, "<numpartners>%d</numpartners>\n", 
			  total_numpartners);
	/*	GtableAddEntry(gtable, -1, -1, "<Topology>\n");
	GtableAddEntryFmt(gtable, -1, -1, "<numsent>%d</numsent>\n",
			  2);
	GtableAddEntryFmt(gtable, -1, -1, "<tavgmsg>%f</tavgmsg>\n",
			  avg_time);
	GtableAddEntryFmt(gtable, -1, -1, "<tstdev>%f</tstdev>\n",
			  stddev_time);
	  GtableAddEntry(gtable, -1, -1, "</Topology>\n");*/
	GtableAddEntry(gtable, -1, -1, "</AppComm>\n");
	GtableNewRow( gtable );
	
	    /*	    GtableAddEntryFmt(gtable, -1, -1, "%-20s", name );
	    GtableAddEntryFmt(gtable, -1, -1, "%s", max_bin_names[i]);
	    GtableAddEntryFmt(gtable, -1, -1, "%d", mincalls[i]);
	    GtableAddEntryFmt(gtable, -1, -1, "%d", maxcalls[i]);
	    GtableAddEntryFmt(gtable, -1, -1, "%d", sumcalls[i]/nprocs);
	    GtableAddEntryFmt(gtable, -1, -1, "%d", minloc[i]);
	    GtableAddEntryFmt(gtable, -1, -1, "%d", maxloc[i]); 
	    GtableNewRow( gtable );
	    GtableAddEntryFmt(gtable, -1, -1, "%ld", minsizes[i]);
	    GtableAddEntryFmt(gtable, -1, -1, "%ld", maxsizes[i]);
	    GtableAddEntryFmt(gtable, -1, -1, "%ld", sumsizes[i]/nprocs);
	    GtableAddEntryFmt(gtable, -1, -1, "%d",  minsizeloc[i]);
	    GtableAddEntryFmt(gtable, -1, -1, "%d",  maxsizeloc[i]);
	    GtableNewRow( gtable );
	    GtableAddEntryFmt(gtable, -1, -1, "%f", mintimes[i]);
	    GtableAddEntryFmt(gtable, -1, -1, "%f", maxtimes[i]);
	    GtableAddEntryFmt(gtable, -1, -1, "%f", sumtimes[i]/nprocs);
	    GtableAddEntryFmt(gtable, -1, -1, "%d", mintimeloc[i]);
	    GtableAddEntryFmt(gtable, -1, -1, "%d", maxtimeloc[i]);
	    if (timesync) {
	      GtableNewRow( gtable );
	      GtableAddEntryFmt(gtable, -1, -1, "%f", minsynctimes[i]);
	      GtableAddEntryFmt(gtable, -1, -1, "%f", maxsynctimes[i]);
	      GtableAddEntryFmt(gtable, -1, -1, "%f", sumsynctimes[i]/nprocs);
	      GtableAddEntryFmt(gtable, -1, -1, "%d", mintimesyncloc[i]);
	      GtableAddEntryFmt(gtable, -1, -1, "%d", maxtimesyncloc[i]);
	      }
	    else {
	    GtableNewRow( gtable );
	    }*/
#else
	fprintf(pf, "\n");
	fprintf(pf,"<AppComm>\n");
	fprintf(pf,"<PIB>123456</PIB>\n");
	fprintf(pf,"<commtype>%s</commtype>\n", name);
	fprintf(pf,"<numcalls>%d</numcalls>\n", total_numcalls);
	fprintf(pf,"<time>%f</time>\n", avg_time*total_numcalls);
	fprintf(pf,"<avgmsg>%f</avgmsg>\n", avg_size);
	fprintf(pf,"<stddev_size>%f</stddev_size>\n", stddev_size);
	fprintf(pf,"<stddev_time>%f</stddev_time>\n", stddev_time);
	fprintf(pf,"<numpartners>%d</numpartners>\n", total_numpartners);
	fprintf(pf,"</AppComm>\n");
	fprintf(pf,"\n");
#endif /* GTABLE */
      }

      /* Create *.html and *.dot files for topology data */
      
      if (total_numcalls > 0) {

	/* Open a file named 'name'.html to store this info in */
	if (getenv("MPI_PROFILE_DIR") != NULL){
	  sprintf(htmlname, "%s/%s.html", getenv("MPI_PROFILE_DIR"),name);
	  sprintf(nfname, "%s/%s.dot",  getenv("MPI_PROFILE_DIR"),name);
	}
	/*	sprintf(nfname, "%s.html", name);*/
	/* FIXME: This appears to provide a link to a picture of the
	   communication partners */
	hfp = fopen(htmlname,"w");
	fprintf(hfp,"<html>\n<head><title>%s</title></head>\n<body bgcolor=\"white\">\n",name);
	fprintf(hfp,"<h1>Communication Partners used by %s</h1>\n", name);
	fprintf(hfp,"<center><img src=\"%s.jpg\"></center>\n",  "partners");
	fprintf(hfp,"</body>\n</html>\n");
	fclose(hfp);

	/* And this has no file name! */
	nfp = fopen( nfname, "w" );
	if (!nfp) {
	    fprintf( stderr, "Could not open %s\n", nfname ? nfname : "<NULL>" );
	}
	else {
	    fprintf(nfp,"digraph G {label=\"{calls, size, time}\"\n");
	    for (j=0;j<nprocs;j++) {
		for (i=0;i<MAX_PROCS;i++) {
		    if (g_comm_partners[j*MAX_PROCS+i] > 0){
			call_lbl = g_comm_partners[j*MAX_PROCS+i];
			size_lbl = g_comm_sizes[j*MAX_PROCS+i];
			time_lbl = g_comm_times[j*MAX_PROCS+i];
			sprintf(label,"{%d, %ld, %f}", call_lbl, size_lbl, time_lbl);
			fprintf(nfp,"%d -> %d [color=\"red\", fontsize=\"9\", label=\"%s\"];\n", j, i, label);
		    }
		}
	    }
	/*	fprintf(nfp,"</body>\n</html>\n");*/
	    fprintf(nfp,"}\n");
	    fclose(nfp);
	}
      }
  }
}
#endif
